﻿using Bharabas.Data;
using Bharabas.Models;
using Bharabas.Scraping;
using Microsoft.AspNetCore.Mvc;
using System.Collections.Immutable;
using System.Diagnostics;

namespace Bharabas.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;
        private readonly ApplicationDbContext _db;
        private readonly IHttpClientFactory _httpClientFactory;

        public HomeController(ApplicationDbContext db)
        {
            //_logger = logger;
            _db = db;
            //_httpClientFactory = httpClientFactory;
        }

        public IActionResult Index(int pg=1, string q = "", string category_ids = ".", string categoryChoosen = "")
        {
			//ScrapingYouTube scrapingYouTube = new ScrapingYouTube(_db);
			//ScrapingListenNotes scrapper = new ScrapingListenNotes(_db);
			//ScrapingGooglePodcast scrapingGooglePodcast = new ScrapingGooglePodcast(_db, _httpClientFactory);
			//await scrapingGooglePodcast.scrapeDataAsync(); // NOTE: ubah return-value jadi async Task<IActionResult> kl mau jalan. Jalannya lama 10 mnt dan cuma dapet 215 audio wk.
			//ScrapingAnchor scrapingAnchor= new ScrapingAnchor(_db, _httpClientFactory);
			//await scrapingAnchor.scrapeDataAsync();

			if (categoryChoosen != "")
			{
                if (category_ids == ".")
                {
                    category_ids = categoryChoosen + category_ids;
                }
                else
                {
                    if (category_ids.Contains(categoryChoosen + ".") || category_ids.Contains(categoryChoosen + ",")) {
                        category_ids = category_ids.Replace(categoryChoosen + ".", "").Replace(categoryChoosen + ",","");
                        if(category_ids == "")
                        {
                            category_ids = ".";
                        }
                        else if (category_ids[category_ids.Length - 1] != '.')
                        {
                            char[] chars = category_ids.ToCharArray();
                            chars[chars.Length - 1] = '.';
                            category_ids = new string(chars);
                        }
                    }
                    else
                    {
                        category_ids = categoryChoosen + "," + category_ids;
                    }
					
				}

			}

			var objAudioList = this.getSearchResult(q, category_ids, pg);

            const int pageSize = 4;
            if (pg < 1)
                pg = 1;

            int recsCount = objAudioList.Count();

            var pager = new Pager(recsCount, pg, pageSize);
            int recSkip = (pg - 1) * pageSize;

            var data = objAudioList.Skip(recSkip).Take(pager.PageSize).ToList();
            this.ViewBag.Pager = pager;
            this.ViewBag.q = q;
            this.ViewBag.category_ids = category_ids;
            this.ViewBag.listCategory = _db.Category.ToList();

            //return View(objAudioList);

            return View(data);
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }

        public IActionResult Search(string q = "", string category_ids = ".", int pg = 1, string categoryChoosen = "")
        {
            if (pg < 1) pg = 1;
            if (categoryChoosen != "")
            {
                if (category_ids == ".")
                {
                    category_ids = categoryChoosen + category_ids;
                }
                else
                {
                    if (category_ids.Contains(categoryChoosen + ".") || category_ids.Contains(categoryChoosen + ","))
                    {
                        category_ids = category_ids.Replace(categoryChoosen + ".", "").Replace(categoryChoosen + ",", "");
                        if (category_ids == "")
                        {
                            category_ids = ".";
                        }else if (category_ids[category_ids.Length - 1] != '.')
                        {
                            char[] chars = category_ids.ToCharArray();
                            chars[chars.Length-1] = '.';
                            category_ids = new string(chars);
                        }
                    }
                    else
                    {
                        category_ids = categoryChoosen + "," + category_ids;
                    }

                }

            }
            var objAudioList = this.getSearchResult(q, category_ids, pg);
            var pager = new Pager(objAudioList.Count(), pg, 6);
            int recSkip = (pg - 1) * pager.PageSize;
            var data = objAudioList.Skip(recSkip).Take(pager.PageSize).ToList();
            this.ViewBag.Pager = pager;
            this.ViewBag.q = q;
            this.ViewBag.category_ids = category_ids;
            return View(data);
        }

        public IEnumerable<Audio> getSearchResult(string q, string category_ids,int pg)
        {
            IEnumerable<Audio> objAudioList;
			if (q != string.Empty && category_ids != ".")
            {
                HashSet<int> categoryIds = new HashSet<int>();
                category_ids.Replace(".","").Split(',').ToList().ForEach(id => categoryIds.Add(Int32.Parse(id)));
                var idFiltered = _db.AudioCategoryRelation.Where(u => categoryIds.Contains(u.categoryId)).Select(u => u.audioId).ToImmutableHashSet();

                objAudioList = _db.AudioList.Where(u => u.title.ToLower().Contains(q.ToLower()) && idFiltered.Contains(u.audioId)).ToList();
            }
            else if (q != string.Empty)
            {
                objAudioList = _db.AudioList.Where(u => u.title.ToLower().Contains(q.ToLower())).ToList();
            }
            else if (category_ids != ".")
            {
                HashSet<int> categoryIds = new HashSet<int>();
                category_ids.Replace(".", "").Split(',').ToList().ForEach(id => categoryIds.Add(Int32.Parse(id)));
                var idFiltered = _db.AudioCategoryRelation.Where(u => categoryIds.Contains(u.categoryId)).Select(u => u.audioId).ToImmutableHashSet();
                objAudioList = _db.AudioList.Where(u => idFiltered.Contains(u.audioId));
            }
            else
            {
                objAudioList = _db.AudioList.ToList();
            }
            return objAudioList;
        }
    }
}