﻿using Bharabas.Models;
using Microsoft.EntityFrameworkCore;


namespace Bharabas.Data
{
    public class ApplicationDbContext :DbContext
    {
        public ApplicationDbContext(DbContextOptions<ApplicationDbContext> options) : base(options) { }
        
        public DbSet<Audio> AudioList { get; set; }

        public DbSet<Category> Category { get; set; }

        public DbSet<CommentLog> CommentLog { get; set; }

        public DbSet<LikeLog> LikeLog { get; set; }

        public DbSet<ShareLog> ShareLog { get; set; }

        public DbSet<AudioCategoryRelation> AudioCategoryRelation { get; set; }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<AudioCategoryRelation>()
                .HasKey(o => new { o.audioId, o.categoryId });
        }
    }


}
