﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace Bharabas.Migrations
{
    /// <inheritdoc />
    public partial class changeAudioTableNamev2 : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_AudioCategoryRelation_AudioList_audioId",
                table: "AudioCategoryRelation");

            migrationBuilder.DropForeignKey(
                name: "FK_CommentLog_AudioList_audioId",
                table: "CommentLog");

            migrationBuilder.DropForeignKey(
                name: "FK_LikeLog_AudioList_audioId",
                table: "LikeLog");

            migrationBuilder.DropForeignKey(
                name: "FK_ShareLog_AudioList_audioId",
                table: "ShareLog");

            migrationBuilder.DropPrimaryKey(
                name: "PK_AudioList",
                table: "AudioList");

            migrationBuilder.RenameTable(
                name: "AudioList",
                newName: "Audio");

            migrationBuilder.AddPrimaryKey(
                name: "PK_Audio",
                table: "Audio",
                column: "audioId");

            migrationBuilder.AddForeignKey(
                name: "FK_AudioCategoryRelation_Audio_audioId",
                table: "AudioCategoryRelation",
                column: "audioId",
                principalTable: "Audio",
                principalColumn: "audioId",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_CommentLog_Audio_audioId",
                table: "CommentLog",
                column: "audioId",
                principalTable: "Audio",
                principalColumn: "audioId",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_LikeLog_Audio_audioId",
                table: "LikeLog",
                column: "audioId",
                principalTable: "Audio",
                principalColumn: "audioId",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_ShareLog_Audio_audioId",
                table: "ShareLog",
                column: "audioId",
                principalTable: "Audio",
                principalColumn: "audioId",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_AudioCategoryRelation_Audio_audioId",
                table: "AudioCategoryRelation");

            migrationBuilder.DropForeignKey(
                name: "FK_CommentLog_Audio_audioId",
                table: "CommentLog");

            migrationBuilder.DropForeignKey(
                name: "FK_LikeLog_Audio_audioId",
                table: "LikeLog");

            migrationBuilder.DropForeignKey(
                name: "FK_ShareLog_Audio_audioId",
                table: "ShareLog");

            migrationBuilder.DropPrimaryKey(
                name: "PK_Audio",
                table: "Audio");

            migrationBuilder.RenameTable(
                name: "Audio",
                newName: "AudioList");

            migrationBuilder.AddPrimaryKey(
                name: "PK_AudioList",
                table: "AudioList",
                column: "audioId");

            migrationBuilder.AddForeignKey(
                name: "FK_AudioCategoryRelation_AudioList_audioId",
                table: "AudioCategoryRelation",
                column: "audioId",
                principalTable: "AudioList",
                principalColumn: "audioId",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_CommentLog_AudioList_audioId",
                table: "CommentLog",
                column: "audioId",
                principalTable: "AudioList",
                principalColumn: "audioId",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_LikeLog_AudioList_audioId",
                table: "LikeLog",
                column: "audioId",
                principalTable: "AudioList",
                principalColumn: "audioId",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_ShareLog_AudioList_audioId",
                table: "ShareLog",
                column: "audioId",
                principalTable: "AudioList",
                principalColumn: "audioId",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
