﻿using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace Bharabas.Models
{
    [Table("Audio")]
    public class Audio
    {
        [Key]
        public int audioId { get; set; }
        
        [Required]
        public string title { get; set; } = string.Empty;

        [Required]
        public string description { get; set; } = string.Empty;

        [Required]
        public string url { get; set; } = string.Empty;

        [Required]
        public string imageUrl { get; set; } = string.Empty;

        [Required] public string platformUrl { get; set; } = string.Empty;

        [Required]
        public string contentCreator { get; set; } = string.Empty;

        [Required]
        public string platform { get; set; } = string.Empty;

        [Required]
        public int duration { get; set; } = 0;

        [Required]
        public DateOnly dateUploaded { get; set; } = DateOnly.FromDateTime(DateTime.Now);

        [Required]
        public DateTime lastUpdated { get; set; } = DateTime.Now;

        [Required]
        public int likesCount { get; set; } = 0;
    }
}
