﻿using Bharabas.Data;
using Bharabas.Models;
using HtmlAgilityPack;

namespace Bharabas.Scraping
{
    public class Util
    {
        public static bool isAudioPathExist(ApplicationDbContext _db, string path)
        {
            var audio = _db.AudioList.Where(u => u.url == path).Select(u => u.url).ToList();
            return audio.Count != 0;
        }

        public static string formatStr(string str)
        {
            return str.Replace("amp;", "").Replace("&#x27;", "\'").Replace("&nbsp;", " ").Replace("\n", "");
        }

        public static int toSecond(string str)
        {
            int ret = 0;
            int i = str.Length - 1;
            List<int> smh = new List<int>();
            int kali = 1;
            while(i >=1)
            {
                smh.Add((str[i - 1] - '0') * 10 + (str[i]-'0'));
                ret += smh.Last() * kali;
                kali *= 60;
                i -= 3;
            }
            return ret;
        }

        public static string parseDate(string str)
        {
            List<string> listDate = new List<string> { "Jan", "Feb", "March", "April", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec" };
            char[] delimiterChars = { ' ' };

            string[] words = str.Split(delimiterChars);
            string ret = "";
            for (int i = 0; i < words.Length; i++)
            {
                words[i] = formatStr(words[i].Replace(",", "").Replace(".", ""));
            }
            ret += words[2].ToString();
            ret += "-";
            for (int i = 0; i < 12; i++)
            {
                if (listDate[i] == words[0])
                {
                    if (i + 1 < 10)
                    {
                        ret += "0";
                    }
                    ret += (i + 1).ToString();
                }
            }
            ret += "-";
            if (words[1].ToString().Length == 1)
            {
                ret += "0";
            }
            ret += words[1].ToString();

            return ret;
        }

        public static int findAndUpdateCategoryID(ApplicationDbContext _db, string categoryName)
        {
            var categoryID = _db.Category.Where(u => u.name == categoryName).Select(u => u.categoryId).ToList();

            if (categoryID.Count == 0)
            {
                Category objCategory = new Category();
                objCategory.name = categoryName;
                _db.Category.Add(objCategory);
                _db.SaveChanges();

                categoryID = _db.Category.Where(u => u.name == categoryName).Select(u => u.categoryId).ToList();
            }
            Console.WriteLine(categoryID[0]);
            return categoryID[0];
        }

        public static string ConvertToPlainText(string html)
        {
            HtmlDocument doc = new HtmlDocument();
            doc.LoadHtml(html);

            StringWriter sw = new StringWriter();
            ConvertTo(doc.DocumentNode, sw);
            sw.Flush();
            return sw.ToString();
        }

        private static void ConvertContentTo(HtmlNode node, TextWriter outText)
        {
            foreach (HtmlNode subnode in node.ChildNodes)
            {
                ConvertTo(subnode, outText);
            }
        }

        private static void ConvertTo(HtmlNode node, TextWriter outText)
        {
            string html;
            switch (node.NodeType)
            {
                case HtmlNodeType.Comment:
                    // don't output comments
                    break;

                case HtmlNodeType.Document:
                    ConvertContentTo(node, outText);
                    break;

                case HtmlNodeType.Text:
                    // script and style must not be output
                    string parentName = node.ParentNode.Name;
                    if ((parentName == "script") || (parentName == "style"))
                        break;

                    // get text
                    html = ((HtmlTextNode)node).Text;

                    // is it in fact a special closing node output as text?
                    if (HtmlNode.IsOverlappedClosingElement(html))
                        break;

                    // check the text is meaningful and not a bunch of whitespaces
                    if (html.Trim().Length > 0)
                    {
                        outText.Write(HtmlEntity.DeEntitize(html));
                    }
                    break;

                case HtmlNodeType.Element:
                    switch (node.Name)
                    {
                        case "p":
                            // treat paragraphs as crlf
                            outText.Write("\r\n");
                            break;
                        case "br":
                            outText.Write("\r\n");
                            break;
                    }

                    if (node.HasChildNodes)
                    {
                        ConvertContentTo(node, outText);
                    }
                    break;
            }
        }
    }
}
