﻿// Listener to change platform image based on platform selector value
const dropdownItems = document.querySelectorAll(".platform-item");
console.log(dropdownItems);
let selectedItem = null;
dropdownItems.forEach(item => {
	item.addEventListener("click", event => {
		selectedItem = {
			platform: event.target.alt,
			logoSrc: event.target.src,
		};
		const selectedDisplay = document.getElementById("selected-platform-item");
		console.log(selectedDisplay);
		selectedDisplay.setAttribute("src", selectedItem.logoSrc);
		selectedDisplay.setAttribute("alt", selectedItem.platform);
		const selectedPlatformValue = document.getElementById("platform-selected");
		selectedPlatformValue.value = selectedItem.platform;
	});
});

// Listener to update the cover image based on image source (textarea) input
const imageView = document.getElementById("image-song");
console.log(imageView);
const imageURL = document.getElementById("image-source");
console.log(imageURL);
imageURL.addEventListener("input", function () {
	imageView.setAttribute("src", imageURL.value);
})
imageView.onerror = function () {
	imageView.setAttribute("src", "https://www.freeiconspng.com/thumbs/no-image-icon/no-image-icon-4.png");
}

// Listener to compute audio duration automatically
const audioSource = document.getElementById("audio-source");
console.log(audioSource);
const audioPlayer = document.getElementById("audio-player");
console.log(audioPlayer);
const audioPath = document.getElementById("audio-path");
console.log(audioPlayer);
const duration = document.getElementById("duration");
console.log(duration);
var submitBtn = document.getElementById('submit');
console.log(submitBtn);
audioSource.addEventListener('input', function () {
	audioPath.src = audioSource.value
	submitBtn.disabled = true
	audioPlayer.load()
})
audioPlayer.onloadedmetadata = function () {
	duration.value = audioPlayer.duration.toString()
	submitBtn.disabled = false
}