﻿const playBtn = document.getElementsByClassName("play");
const slider = document.getElementById("slider");
var isPlayingSong = false;
var isFromSpotify = false;
var isFromYouTube = false;
var currentPlayed = 0;
var spotifyController = null;
var spotifyDuration = undefined;
var spotifyCurrentTime = 0;
var duration = undefined;
var youTubeCurrentTime = 0;
var dontUpdate = false;


for (let i = 0; i < playBtn.length; i++) {
    playBtn[i].addEventListener("click", e => {


        document.getElementsByTagName("footer")[0].style.display = "block"

        let control = document.getElementById('song-audio');
        let song = document.getElementById('song-path');

        let audioUrl = playBtn[i].getElementsByClassName("audio-url")[0].value;

        let platform = playBtn[i].getElementsByClassName("platform")[0].value;

        duration = playBtn[i].getElementsByClassName("duration")[0].value;


        if (platform == "YouTube") {
            isFromYouTube = true;
        }

        changeVideo(audioUrl);

        isFromSpotify = audioUrl.startsWith("spotify");
        song.src = audioUrl;
        currentPlayed = i;
        if (!isFromSpotify) {
            control.load();
        } else {
            loadSpotify(audioUrl);
            dontUpdate = true;
        }
        slider.value = 0

        let picture = document.getElementById("song-picture")
        picture.src = document.getElementsByClassName("img-song")[currentPlayed].src

        let title = document.getElementById("song-title")
        title.innerHTML = document.getElementsByClassName("title-song")[currentPlayed].innerHTML

        let artist = document.getElementById("song-artist")
        artist.innerHTML = document.getElementsByClassName("artist-song")[currentPlayed].value


        document.getElementsByClassName("song-control")[0].innerHTML = '<span class="fa fa-pause" style="color: rgba(0, 0, 0, .54); font-size: 1.4em"></span>'
    })
}

const controlSong = document.getElementsByClassName("song-control")[0];
controlSong.addEventListener('click', e => {
    let control = document.getElementById('song-audio');
    if (isPlayingSong) {
        if (isFromSpotify) {
            toggleSpotify();
        } else if (isFromYouTube) {
            pauseVideo();
        } else {
            control.pause();
        }
        document.getElementsByClassName("song-control")[0].innerHTML = '<span class="fa fa-play" style="color: rgba(0, 0, 0, .54); font-size: 1.4em"></span>'
    } else {
        if (isFromSpotify) {
            toggleSpotify();
        } else if (isFromYouTube) {
            playVideo();
        } else {
            control.play();
        }
        document.getElementsByClassName("song-control")[0].innerHTML = '<span class="fa fa-pause" style="color: rgba(0, 0, 0, .54); font-size: 1.4em"></span>'
    }
    isPlayingSong ^= true;
})

const ad = document.getElementById("song-audio")
ad.onloadedmetadata = function () {
    console.log('masuk')
    document.getElementsByTagName("footer")[0].style.display = "block"
    let control = document.getElementById('song-audio');
    control.play()

    isPlayingSong = true;
}

var updateSlider = function () {
    if (isFromSpotify) {
        if (isNaN(spotifyDuration)) {
            slider.disabled = true;
            return;
        }
        if (!isPlayingSong) return;
        if (dontUpdate) {
            dontUpdate = false;
            return;
        }
        let sliderProgress = spotifyCurrentTime / spotifyDuration;
        if (sliderProgress > 1) {
            sliderProgress = 1
        }
        if (sliderProgress == 1) {
            slider.value = 0;
            spotifyController.seek(0);
            document.getElementsByClassName("song-control")[0].innerHTML = '<span class="fa fa-play" style="color: rgba(0, 0, 0, .54); font-size: 1.4em"></span>'
            isPlayingSong = false;
            return;
        }
        slider.disabled = false;
        console.log(sliderProgress)
        slider.value = sliderProgress * 1000;
    } else if (isFromYouTube) {

        youTubeCurrentTime = player.getCurrentTime();

        if (isNaN(duration)) {
            slider.disabled = true;
            return;
        }
        if (!isPlayingSong) return;
        if (dontUpdate) {
            dontUpdate = false;
            return;
        }
        let sliderProgress = youTubeCurrentTime / duration;
        if (sliderProgress > 1) {
            sliderProgress = 1
        }
        if (sliderProgress == 1) {
            slider.value = 0;
            player.seekTo(0, true);
            document.getElementsByClassName("song-control")[0].innerHTML = '<span class="fa fa-play" style="color: rgba(0, 0, 0, .54); font-size: 1.4em"></span>'
            isPlayingSong = false;
            return;
        }
        slider.disabled = false;
        console.log(sliderProgress)
        slider.value = sliderProgress * 1000;
    } else {
        if (isNaN(ad.duration)) {
            slider.disabled = true;
        }
        if (!isPlayingSong || isNaN(ad.duration)) return;
        let sliderProgress = ad.currentTime / ad.duration
        if (sliderProgress > 1) {
            sliderProgress = 1
        }
        if (sliderProgress == 1) {
            slider.value = 0;
            ad.currentTime = 0;
            let control = document.getElementById('song-audio');
            control.pause()
            document.getElementsByClassName("song-control")[0].innerHTML = '<span class="fa fa-play" style="color: rgba(0, 0, 0, .54); font-size: 1.4em"></span>'
            isPlayingSong = false;
            return;
        }
        slider.disabled = false;
        console.log(sliderProgress)
        slider.value = sliderProgress * 1000;
    }
}

slider.oninput = function () {
    let value = this.value
    let audioProgress = (value / 1000);
    if (isFromSpotify) {
        audioProgress = audioProgress * spotifyDuration
        console.log(value / 1000);
        dontUpdate = true;
        spotifyCurrentTime = audioProgress;
        spotifyController.seek(audioProgress);
    } else if (isFromYouTube) {
        audioProgress = audioProgress * duration;
        console.log(value / 1000);
        dontUpdate = true;
        youTubeCurrentTime = audioProgress;
        player.seekTo(youTubeCurrentTime, true);
    } else if (!isFromSpotify && !isFromYouTube) {
        audioProgress = audioProgress * ad.duration;
        if (audioProgress > ad.duration) {
            audioProgress = ad.duration
        }
        ad.currentTime = audioProgress
    }
}

setInterval(updateSlider, 1000)

// just for spotify iframe
window.onSpotifyIframeApiReady = (IFrameAPI) => {
    let element = document.getElementById('embed-iframe');
    let options = {
    };
    let callback = (EmbedController) => {
        let iframeEl = document.getElementsByTagName("iframe")[0];
        iframeEl.setAttribute("hidden", true);
        iframeEl.setAttribute("loading", "eager");
        EmbedController.addListener("playback_update", (e) => {
            spotifyDuration = e.data.duration / 1000;
            spotifyCurrentTime = e.data.position / 1000;
        })
        spotifyController = EmbedController;
    };
    IFrameAPI.createController(element, options, callback);
};

let loadSpotify = (uri) => {
    spotifyDuration = undefined;
    spotifyController.loadUri(uri);
    spotifyController.play();
    isPlayingSong = true;
}

let toggleSpotify = () => {
    spotifyController.togglePlay();
}

// For YouTube
var tag = document.createElement('script');

tag.src = "https://www.youtube.com/iframe_api";
var firstScriptTag = document.getElementsByTagName('script')[0];
firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);

var player;
function onYouTubeIframeAPIReady() {
    player = new YT.Player('player', {
        height: '0',
        width: '0',
        events: {
            'onReady': onPlayerReady,
        }
    });
}

function onPlayerReady(event) {
    event.target.playVideo();
    isPlayingSong = true;
}

function pauseVideo() {
    player.pauseVideo();
}

function playVideo() {
    player.playVideo();
}

function stopVideo() {
    player.stopVideo();
}

function changeVideo(playerId) {
    player.loadVideoById(playerId, 0, "large");
    isPlayingSong = true;
}